//Includes
#include <cstdio>
#include <cstdlib>
#include <vector_types.h>
#include <cuda.h>

//Libs -- apenas Visual C++
#pragma comment (lib, "cuda.lib")
#pragma comment (lib, "cudart.lib")

//Constantes
#define TAMANHO 16

//Funes do arquivo kernel.cu
extern "C" void FuncaoEmCPU(void);
extern "C" void SomaVetoresCPU(float *vetC, float *vetA, float *vetB, int tamanho);
extern "C" void SomaVetoresGPU(float *vetC, float *vetA, float *vetB, int tamanho);

//Variveis globais
float VetorA[TAMANHO],
	  VetorB[TAMANHO],
	  VetorC[TAMANHO];

//------------------------------------------------------
//
//------------------------------------------------------
void Imprimir(void)
{
	printf("\n VetA \t\t VetB \t\t VetC");
	for (int i = 0; i < TAMANHO; i++)
		printf("\n %f \t %f \t %f", VetorA[i], VetorB[i], VetorC[i]);
}


//------------------------------------------------------
//
//------------------------------------------------------
int main (int argc, char **agrv)
{
	float valor = 1.0f;
	printf("\nOla CUDA");

	//iniciando vetores.
	for (int i = 0; i < TAMANHO; i++)
	{
		VetorA[i] = valor * 100.0f;
		VetorB[i] = valor / 100.0f;
		VetorC[i] = 0.0f;	
	}

	Imprimir();
//	SomaVetoresCPU(&VetorC[0], &VetorA[0], &VetorB[0], TAMANHO);
	SomaVetoresGPU(&VetorC[0], &VetorA[0], &VetorB[0], TAMANHO);
	Imprimir();
	FuncaoEmCPU();

	printf("\n\n");
	system("pause");
	return EXIT_SUCCESS;
}
