#ifndef _KERNEL_H_
#define _KERNEL_H_
#include <stdio.h>

#define BLOCOS 2  //Ateno para o tamanho do bloco (no pode ser maior que os dados a serem processados).

//------------------------------------------------------
//
//------------------------------------------------------
__global__ void ImagemBWKernel(uchar4 *B)
{
	/*
	 *	blockIdx.x    --> ndice do bloco.
	 *  blockDim.x    --> tamanho do bloco.
	 *  threadIdx.x   --> ndice da thread.
	 */
	const unsigned int 
		indice = (blockIdx.x * blockDim.x) + threadIdx.x;
	unsigned char 
		med = (B[indice].x + B[indice].y + B[indice].z) / 3;
	B[indice].x = med;
	B[indice].y = med;
	B[indice].z = med;
	

	/*
	B[indice].x = B[indice].z;
	B[indice].y = B[indice].y;
	B[indice].z = B[indice].x;
	*/
	//B[indice].w = 255 - B[indice].w;
}

//------------------------------------------------------
//
//------------------------------------------------------
__global__ void ImagemBGRKernel(uchar4 *B)
{
	/*
	 *	blockIdx.x    --> ndice do bloco.
	 *  blockDim.x    --> tamanho do bloco.
	 *  threadIdx.x   --> ndice da thread.
	 */
	const unsigned int indice = 
		(blockIdx.x * blockDim.x) + threadIdx.x;

	B[indice].x = B[indice].z;
	B[indice].y = B[indice].y;
	B[indice].z = B[indice].x;
	//B[indice].w = 255 - B[indice].w;
}

//------------------------------------------------------
//
//------------------------------------------------------
extern "C" void runGPU(uchar4 *buffer, unsigned int w, unsigned int h, int type)
{
	//Variveis
	
	
	dim3  Grid(w, 1, 1), 
         thread(h, 1, 1);

	//Sincronizando - verifica se h erros!!!
/*	if (cudaSuccess != cudaThreadSynchronize())
	{
		fprintf(stderr, "\nError in cudaThreadSynchronize");
		getc(stdin);
		exit(EXIT_FAILURE);
	}
	*/
	//Executando kernel.
	if (type)
		ImagemBWKernel<<<Grid, thread>>>(buffer);
	else
		ImagemBGRKernel<<<Grid, thread>>>(buffer);
	/*if (cudaSuccess != cudaThreadSynchronize())
	{
		fprintf(stderr, "\nError in kernel");
		getc(stdin);
		exit(EXIT_FAILURE);
	}
*/

}


#endif